//-----------------------------------------------------------------------------
//
//  $Logfile:: /Source/r_sinmdl.h                                              $
// $Revision:: 2                                                               $
//   $Author:: Burgermac                                                       $
//     $Date:: 12/27/00 6:01 PM                                                $
//
// Copyright (C) 1998 by Ritual Entertainment, Inc.
// All rights reserved.
//
// This source is may not be distributed and/or modified without
// expressly written permission by Ritual Entertainment, Inc.
//
// DESCRIPTION:
// Sin model loading and drawing
//

#ifndef __R_SINMDL_H__
#define __R_SINMDL_H__

#ifdef __cplusplus
extern "C" {
#endif

/*
=================
SINMDL_LoadSinModel
=================
*/
qboolean SINMDL_LoadSinModel (model_t *mod, void *buffer);

/*
=================
SINMDL_RegisterModel
=================
*/
void SINMDL_RegisterModel( model_t *mod );

/*
=================
SINMDL_FreeModel
=================
*/
void SINMDL_FreeModel( model_t *mod );

/*
=================
SINMDL_GetDefHandle
=================
*/
int SINMDL_GetDefHandle( model_t * mdl );

/*
=================
SINMDL_GetNumFrames
=================
*/
int SINMDL_GetNumFrames( int handle, int anim );

/*
=================
SINMDL_DrawModel
=================
*/
void R_SINMDLDrawModel (void);
void SINMDL_DrawModel (entity_t *e);

#ifdef __cplusplus
}
#endif

#endif

